// MMConversionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rootfly.h"
#include "MMConversionDlg.h"
#include <math.h>

#pragma warning(disable:4355)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(MMConversionColorBox, CColorBox)
//{{AFX_MSG_MAP(MMConversionColorBox)
ON_CONTROL_REFLECT_EX(BN_CLICKED, OnClickedEx)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MMConversionColorBox class
BOOL MMConversionColorBox::OnClickedEx() 
{
  //call parent class OnClicked routine
  CColorBox::OnClickedEx();
  
  //redraw the dialog (with line) after color has been selected
  m_mm_dlg->Redraw();
  
  //Return FALSE. The parent will get the OnClick message.
  return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
// MMConversionDlg dialog

// !!! Need to somehow infom the user that the calibration lines are now adjustable
//     with right clicks

typedef enum
{
  NO_IMAGE,
    IMAGE,
    FIRST_POINT,
    LINE_ADJUSTABLE,
    BETWEEN_LINES
} MODE;

//redraws the conversion dialog after the line color has been changed
void MMConversionDlg::Redraw()
{
  CClientDC dc(this);
  Redraw(dc);
}


MMConversionDlg::MMConversionDlg(CWnd* pParent /*=NULL*/)
: CDialog(MMConversionDlg::IDD, pParent),
  m_root_color(this)
{
  
  CString fname = "";
  m_root_color.SetColor(RGB(255,0,0));
  m_pixels_per_mm = 1.0;
  m_point1 = CPoint(-1,-1);
  m_point2 = CPoint(-1,-1);
  m_mode = NO_IMAGE;
}


void MMConversionDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(MMConversionDlg)
  DDX_Control(pDX, IDC_BUTTON_DELETE_ALL, m_button_delete_all);
  DDX_Control(pDX, IDC_BUTTON_DELETE_LAST, m_button_delete_last);
  DDX_Control(pDX, IDC_LINE_COLOR, m_root_color);
  DDX_Control(pDX, IDC_PICTURE, m_picture_button);
  DDX_Control(pDX, IDC_RADIO_IMAGE, m_radio_image);
  DDX_Control(pDX, IDC_RADIO_100, m_radio_100);
  DDX_Control(pDX, IDC_RADIO_12point5, m_radio_12point5);
  DDX_Control(pDX, IDC_RADIO_50, m_radio_50);
  DDX_Control(pDX, IDC_RADIO_25, m_radio_25);
  DDX_Control(pDX, IDC_TEXT_STATIC, m_text);
  DDX_Control(pDX, IDC_IMAGE, m_image);
  DDX_Control(pDX, IDC_STATIC_PIXELS, m_static_pixels);
  DDX_Control(pDX, IDC_EDIT_CONVERSION, m_edit_conversion);
  DDX_Control(pDX, IDC_EDIT_MILLI, m_edit_milli);
  DDX_Control(pDX, IDC_LINE_COLOR_LABEL, m_line_color_label);
  DDX_Control(pDX, IDC_STATIC_MM_LABEL, m_static_mm_label);
  DDX_Control(pDX, IDC_STATIC_PIXELS_LABEL, m_static_pixels_label);
  //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MMConversionDlg, CDialog)
//{{AFX_MSG_MAP(MMConversionDlg)
ON_WM_RBUTTONDOWN()
ON_WM_LBUTTONDOWN()
ON_WM_MOUSEMOVE()
ON_WM_PAINT()
ON_EN_KILLFOCUS(IDC_EDIT_MILLI, OnKillfocusEditMilli)
ON_BN_CLICKED(IDC_PICTURE, OnPicture)
ON_BN_CLICKED(IDC_RADIO_IMAGE, OnRadioImage)
ON_BN_CLICKED(IDC_RADIO_MANUAL, OnRadioManual)
ON_EN_KILLFOCUS(IDC_EDIT_CONVERSION, OnKillfocusEditConversion)
ON_WM_SIZE()
ON_BN_CLICKED(IDC_BUTTON_DELETE_LAST, OnDeleteLast)
ON_BN_CLICKED(IDC_BUTTON_DELETE_ALL, OnDeleteAllLines)
ON_BN_CLICKED(IDC_RADIO_100, OnRadio100)
ON_BN_CLICKED(IDC_RADIO_50, OnRadio50)
ON_BN_CLICKED(IDC_RADIO_25, OnRadio25)
ON_BN_CLICKED(IDC_RADIO_12point5, OnRADIO12point5)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MMConversionDlg message handlers
BOOL MMConversionDlg::OnInitDialog() 
{
  CDialog::OnInitDialog();
  
  // initial setup
  CString str;
  str.Format("%5.1f", m_pixels_per_mm);  
  m_edit_conversion.SetWindowText(str);
  m_edit_milli.EnableWindow(false);
  m_cur_pen = AfxGetApp()->LoadCursor(IDC_CUR_PEN);
  m_radio_image.SetCheck(BST_CHECKED);
  m_radio_100.SetCheck(BST_CHECKED);
  m_scale = 1;
  // maximize window
  //  WINDOWPLACEMENT wp;
  //  wp.showCmd = SW_SHOWMAXIMIZED;
  //  SetWindowPlacement(&wp);
  
  return TRUE;  
}


void MMConversionDlg::OnPaint() 
{
  CPaintDC dc(this); // device context for painting
  Redraw(dc);
}

// redraws the line along with the picture
void MMConversionDlg::Redraw(CDC &dc)
{
  CRgn clip_rgn;
  CRect rect;
  m_image.GetWindowRect(&rect);
  ScreenToClient(rect);
  int i = 0;
  
  blepo::ImgBgr m_img_scaled;
  blepo::Downsample(m_img, m_scale, m_scale, &m_img_scaled);
  
  // finds the top left point of the image  
  CPoint pt = rect.CenterPoint();
  if(m_img_scaled.Width() > rect.Width()) pt.x = rect.left;
  else pt.x -= m_img_scaled.Width() / 2;
  if(m_img_scaled.Height() > rect.Height()) pt.y = rect.top;
  else pt.y -= m_img_scaled.Height() / 2;
  
  // creates the clip region
  clip_rgn.CreateRectRgnIndirect(CRect(pt.x,pt.y,pt.x+rect.Width(),pt.y+rect.Height()));
  dc.SelectClipRgn(&clip_rgn);
  
  // hides directions if image isn't loaded
  if(m_mode != NO_IMAGE) m_text.ShowWindow(SW_SHOW);
  else m_text.ShowWindow(SW_HIDE);
  
  blepo::Draw(m_img_scaled, dc, pt.x,pt.y);

  for(i = 0; i<m_line_points.size(); i+=2)
  {
    m_point1 = m_line_points[i];
    m_point2 = m_line_points[i+1];
    
    // draw line
    if (m_point1.x >= 0)
    {
      CPen pen(PS_SOLID, 1, m_root_color.GetColor());
      CPen* old = dc.SelectObject(&pen);
      dc.MoveTo(m_point1);
      dc.LineTo(m_point2);
      dc.SelectObject(old);
    }
    
  }
}


void MMConversionDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
  CClientDC dc(this);
  CRect rect;
  m_image.GetWindowRect(&rect);
  ScreenToClient(rect);
  
  
  
  if(m_mode != NO_IMAGE)
  {
    // finds the top left point of the image
    CPoint pt = rect.CenterPoint();
    if(m_img.Width() > rect.Width()) pt.x = rect.left;
    else pt.x -= m_img.Width() / 2;
    if(m_img.Height() > rect.Height()) pt.y = rect.top;
    else pt.y -= m_img.Height() / 2;
  
    // creates the rect around the image
    rect = CRect(pt.x,pt.y,pt.x+m_img.Width(),pt.y+m_img.Height());
    if (rect.PtInRect(point))
    {
      SetCursor(m_cur_pen);
      if (m_mode == FIRST_POINT)  
      {
        //m_point2 = point;
        m_line_points[m_line_points.size()-1] = point;
        Redraw(dc);
      }
      
    }
  }
  
  CDialog::OnMouseMove(nFlags, point);
}

// grabs the beginning and ending points of the line
void MMConversionDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
  CRect rect;
  m_image.GetWindowRect(&rect);
  ScreenToClient(rect);
  
  // finds the top left point of the image
  CPoint pt = rect.CenterPoint();
  pt.x -= m_img.Width() / 2;
  pt.y -= m_img.Height() / 2;
  
  // creates the rect around the image
  rect = CRect(pt.x,pt.y,pt.x+m_img.Width(),pt.y+m_img.Height());
  
  if (rect.PtInRect(point) && m_mode != NO_IMAGE)
  {
    // this is the beginning 
    if (m_mode != FIRST_POINT)
    {
      m_line_points.push_back(point);
      m_line_points.push_back(point);
      m_mode = FIRST_POINT;
    }
    else
    {
      //std::vector<float> m_pixel_distances;
      // this is the second point. length of line is calculated
      float dx = (float) m_point1.x -  (float) m_point2.x;
      float dy = (float) m_point1.y - (float) m_point2.y;
      float pixels = (m_scale)* ((float) (sqrt(dx * dx + dy * dy) + 0.5f));
      m_pixel_distances.push_back(pixels);
      
      m_avg_pixels = CalculateAvgPixels(m_pixel_distances, m_pixel_distances.size());
      
      float milli = 1.0f;

      CString str;
      str.Format("%5.0f", m_avg_pixels);
      m_static_pixels.SetWindowText(str);
      str.Format("%5.1f", milli);
      m_edit_milli.SetWindowText(str);
      Recalculate();
      m_mode = BETWEEN_LINES;
    }
  }
  CDialog::OnLButtonDown(nFlags, point);
}

void MMConversionDlg::OnKillfocusEditMilli() 
{
  Recalculate();	
}

void MMConversionDlg::OnKillfocusEditConversion() 
{
  CString str;
  m_edit_conversion.GetWindowText(str);
  float val = (float) atof(str);
  m_pixels_per_mm = val;
}

void MMConversionDlg::OnOK() 
{
  if (GetFocus() == GetDlgItem(IDC_EDIT_MILLI))
  {
    Recalculate();
    return;
  }	
  
  CString str;
  m_edit_conversion.GetWindowText(str);
  float conv_val = (float)atof(str);
  m_pixels_per_mm = conv_val;
  
  CDialog::OnOK();
}

// loads the picture onto the dialog
void MMConversionDlg::OnPicture() 
{
  CClientDC dc(this);
  
  CFileDialog dlg(TRUE, "jpg", NULL, OFN_HIDEREADONLY, "JPEG Files (*.jpg)|*.jpg|Bitmap Files (*.bmp)|*.bmp|All Files (*.*)|*.*|");  
  dlg.m_ofn.lpstrTitle = "Load calibration image";
  
  int ret = dlg.DoModal();
  if (ret == IDOK)
  {
    fname = dlg.GetFileName();
    bool success = blepo::Load(fname, &m_img);
    if (!success)
    {
      CString str;
      str.Format("Unable to load file '%s'", (const char*) fname);
      AfxMessageBox(str);
    } 
    else
    {
      GrayImageArea();
      m_mode = IMAGE;
      m_edit_milli.EnableWindow();
      m_root_color.EnableWindow();
      m_radio_100.EnableWindow();
      m_radio_50.EnableWindow();
      m_radio_25.EnableWindow();
      m_radio_12point5.EnableWindow();
      OnDeleteAllLines();
      
      CString str;
      str.Format("%5.1f", 1.0);  
      m_edit_milli.SetWindowText(str);
      OnRadioImage();
      Redraw(dc);
    }
  }
}

// grays out image area
void MMConversionDlg::GrayImageArea()
{
  CClientDC dc(this);
  CRect rect;
  m_image.GetWindowRect(&rect);
  ScreenToClient(rect);
  dc.FillSolidRect(rect,GetSysColor(COLOR_BTNFACE));
}

// calculates the pixel to mm conversion
void MMConversionDlg::Recalculate()
{
  CString str;
  m_edit_milli.GetWindowText(str);
  float mm = (float) atof(str);
  str.Format("%5.1f", mm);
  m_edit_milli.SetWindowText(str);
  m_static_pixels.GetWindowText(str);
  m_pixels_per_mm = m_avg_pixels / mm;
  str.Format("%5.1f", m_pixels_per_mm);
  m_edit_conversion.SetWindowText(str);
}



void MMConversionDlg::SetLineColor(COLORREF color)
{
  m_root_color.SetColor(color);
}

void MMConversionDlg::SetConversion(float conversion)
{
  m_pixels_per_mm = conversion;
}


// grabs the beginning and ending points of the line
void MMConversionDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{

}


// sets the window to use an image for calibration
void MMConversionDlg::OnRadioImage() 
{
  m_static_pixels.ShowWindow(SW_SHOW);
  
  m_edit_milli.SetWindowText("");
  m_edit_milli.ShowWindow(SW_SHOW);

  m_button_delete_last.ShowWindow(SW_SHOW);
  
  m_button_delete_all.ShowWindow(SW_SHOW);
  
  m_edit_conversion.ShowWindow(SW_SHOW);
  m_edit_conversion.SetReadOnly();
  
  m_picture_button.ShowWindow(SW_SHOW);
  
  m_root_color.ShowWindow(SW_SHOW);
  
  m_radio_100.ShowWindow(SW_SHOW);
  
  m_radio_12point5.ShowWindow(SW_SHOW);
  
  m_radio_50.ShowWindow(SW_SHOW);
  
  m_radio_25.ShowWindow(SW_SHOW);
  
  m_line_color_label.ShowWindow(SW_SHOW);
  m_static_mm_label.ShowWindow(SW_SHOW);
  m_static_pixels_label.ShowWindow(SW_SHOW);
  m_mode = IMAGE;
}

// sets the window to use manual calibration
void MMConversionDlg::OnRadioManual() 
{
  GrayImageArea();
  
  m_static_pixels.ShowWindow(SW_HIDE);
  
  m_edit_milli.SetWindowText("");
  m_edit_milli.ShowWindow(SW_HIDE);

  
  m_button_delete_last.ShowWindow(SW_HIDE);
  
  m_button_delete_all.ShowWindow(SW_HIDE);
  
  m_edit_conversion.ShowWindow(SW_SHOW);

  m_edit_conversion.SetReadOnly(FALSE);
  

  m_picture_button.ShowWindow(SW_HIDE);
  
  m_root_color.ShowWindow(SW_HIDE);
  
  m_radio_100.ShowWindow(SW_HIDE);
  
  m_radio_12point5.ShowWindow(SW_HIDE);
  
  m_radio_50.ShowWindow(SW_HIDE);
  
  m_radio_25.ShowWindow(SW_HIDE);

  m_line_color_label.ShowWindow(SW_HIDE);
  m_static_mm_label.ShowWindow(SW_HIDE);
  m_static_pixels_label.ShowWindow(SW_HIDE);
  
  m_mode = NO_IMAGE;
  
  
}


void MMConversionDlg::OnSize(UINT nType, int cx, int cy) 
{
  CDialog::OnSize(nType, cx, cy);
  
  
  
}

void MMConversionDlg::OnDeleteLast() 
{
  CString str;
  CClientDC dc(this);
  
  if( !(m_line_points.empty()) )
  {
    //Remove the last 2 points from the vector of points
    m_line_points.pop_back();
    m_line_points.pop_back();
  
    //Remove the last pixel length
    m_pixel_distances.pop_back();
  
    //Recalculate average pixels
    m_avg_pixels = CalculateAvgPixels(m_pixel_distances, m_pixel_distances.size());
  
    //update the average pixels box
    str.Format("%5.0f", m_avg_pixels);
    m_static_pixels.SetWindowText(str);
  }

  //if all lines are gone reset all text boxes
  if(m_line_points.empty())
  {
    m_pixels_per_mm = 1.0;
    str.Format("%5.1f", m_pixels_per_mm);
    m_edit_conversion.SetWindowText(str);
    m_edit_milli.SetWindowText("");
    m_static_pixels.SetWindowText("");
  }

  Redraw(dc);
}

void MMConversionDlg::OnDeleteAllLines() 
{
  CClientDC dc(this);
  CString str;
  
  // Remove all items from the vector of points and redraw
  m_line_points.erase(m_line_points.begin(),m_line_points.end());
  
  //Remove all pixel lengths and recalculate
  m_pixel_distances.erase(m_pixel_distances.begin(), m_pixel_distances.end());
  
  m_pixels_per_mm = 1.0;
  str.Format("%5.1f", m_pixels_per_mm);
  m_edit_conversion.SetWindowText(str);
  
  m_edit_milli.SetWindowText("");
  
  m_static_pixels.SetWindowText("");
  m_avg_pixels = 0;

  Redraw(dc);
}

float MMConversionDlg::CalculateAvgPixels(std::vector<float> pixel_lengths, int number_of_lines)
{
  int i;
  float running_total = 0;
  
  //check to make sure there is something to calculate on
  if(pixel_lengths.size() == 0 || number_of_lines < 1)
  {
    return 0;
  }
  
  //sum all pixel lengths
  for(i = 0; i < pixel_lengths.size(); i++)
  {
    running_total += pixel_lengths[i];
  }
  
  return (running_total/number_of_lines);
}

void MMConversionDlg::OnRadio100() 
{
  
  OnDeleteAllLines();
  GrayImageArea();
  m_scale = 1;
  CClientDC dc(this);
  Redraw(dc);
}


void MMConversionDlg::OnRadio50() 
{
  OnDeleteAllLines();
  GrayImageArea();
  m_scale = 2;
  CClientDC dc(this);
  Redraw(dc);
  
}

void MMConversionDlg::OnRadio25()
{
  OnDeleteAllLines();
  GrayImageArea();
  m_scale = 4;
  CClientDC dc(this);
  Redraw(dc);	
}



void MMConversionDlg::OnRADIO12point5() 
{
  OnDeleteAllLines();
  GrayImageArea();
  m_scale = 8;
  CClientDC dc(this);
  Redraw(dc);
  
}
