/* 
* Rootfly:  A program for analyzing and measuring roots. 
* Copyright (c) 2005 Clemson University.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or (at
* your option) any later version.
* 
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

// RootflyData.h: interface for the RootflyData class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROOTFLYDATA_H__A68F09A6_ECC7_4F50_81DA_4118FAFCB32A__INCLUDED_)
#define AFX_ROOTFLYDATA_H__A68F09A6_ECC7_4F50_81DA_4118FAFCB32A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include "stdafx.h"
#include "RootData.h"
#include <math.h>

namespace OldData
{
  class RootflyData  
  {
  public:
     RootflyData();
     virtual ~RootflyData();
     bool Load(CString& filename);		   // load .rfy file
     void Save(CString& filename);       // save .rfy file
     void Export(CString& filename);     // save .csv file
     void SetModify(bool t = true);
     bool GetModify() const;
     RootData m_root;

     CString m_version;			// version identifier
     CString m_image_format; // image filename's format (ignored as of 4/15/10 -- STB)
     CString m_image_directory;
     float m_mm_conversion;  // mm conversion ratio
  private:
     bool m_modified;
  };

}//namespace OldData


#endif // !defined(AFX_ROOTFLYDATA_H__A68F09A6_ECC7_4F50_81DA_4118FAFCB32A__INCLUDED_)
